CREATE OR REPLACE PROCEDURE CTB_DFE_IMPBONIFIC(
   P_NRLANCTBTEMP LANCCONT.NRLANCCONT%TYPE,
   P_CDFILIAL FILIAL.CDFILIAL%TYPE,
   P_NRLANCTONF NOTAFISCAL.NRLANCTONF%TYPE,
   P_FATOR INT,
   P_VRLANCTO IN OUT LANCCONT.VRLANCAMENT%TYPE)
AS
   V_CDCONTATIPOOPER CONTCTBL.CDCONTCTBL%TYPE;
   V_CDCONTAPROD CONTCTBL.CDCONTCTBL%TYPE;
   V_CDARVPROD PRODUTO.CDARVPROD%TYPE;
   V_VRIMPOSTO LANCCONT.VRLANCAMENT%TYPE;
   V_VRCONTITEM LANCCONT.VRLANCAMENT%TYPE;
   V_TOTALPARTIDAS LANCCONT.VRLANCAMENT%TYPE;
   V_PARTIDAS INT;
   V_CDHISTPADR HISTPADR.CDHISTPADR%TYPE;
   V_DSHISTLANC LANCCONT.DSHISTLANC%TYPE;
   V_IDCOME VARCHAR2(01);
   V_IDCCUS VARCHAR2(01);
   V_CONTCCUS VARCHAR2(01);
   V_CDCOMERCIAL FORNECEDOR.CDFORNECED%TYPE;
   V_NUMPARTIDA INT;
   V_INPARTIDAS INT;
   V_CDFILIAL FILIAL.CDFILIAL%TYPE;
   V_CDCENTCUST CENTCUST.CDCENTCUST%TYPE;
   V_ACUMULA VARCHAR2(01);
   V_COUNT INT;
   V_NRSEQLANC LANCCONT.NRSEQLANC%TYPE;
BEGIN
   FOR NOTA IN
      (SELECT CDEMPRESA, CDFILIRECE, CDCONTPROD, NF.IDENTRSAIDOP, NF.CDTIPOOPER,
              NF.NRNOTAFISC, NF.DTENTRSAID, CDFORNECED, IDORIGDESTNF, CDCLIENTE
         FROM NOTAFISCAL NF, TIPOOPERAC T
        WHERE NF.CDFILIAL = P_CDFILIAL
          AND NF.NRLANCTONF = P_NRLANCTONF
          AND NF.CDTIPOOPER = T.CDTIPOOPER
          AND NF.IDENTRSAIDOP = T.IDENTRSAIDOP)LOOP
         V_CDCONTAPROD := NOTA.CDCONTPROD;

      SELECT IDCONTGERE, IDACUMVRCONT
        INTO V_CONTCCUS, V_ACUMULA
        FROM CONTOPECTBL
       WHERE CDEMPRESA = NOTA.CDEMPRESA;

      /* ARMAZENA A CONTA CONTBIL DE PRODUTO POR TIPO DE OPERAO */
      V_CDCONTATIPOOPER := NOTA.CDCONTPROD;

      /* ZERA A VARIAVEL PARA PODER SOMAR OS VALORE DAS PARTIDAS POSTERIORMENTE */
      V_TOTALPARTIDAS := 0;

      /* VARUAVEL USADA PARA SABER SE EST NA ULTIMA PARTIDA DO BLOCO, CASO ESTEJA  FEITO A MARRETA */
      V_INPARTIDAS := 0;

      /* PEGA O SEQUENCIAL DA ULTIMA PARTIDA DO LANCAMNENTO */
      BEGIN
         SELECT TO_NUMBER(MAX(NRSEQCTBTEMP))
           INTO V_NUMPARTIDA
           FROM LANCCTBTEMP
          WHERE NRLANCCTBTEMP = P_NRLANCTBTEMP
            AND CDEMPRESA = NOTA.CDEMPRESA;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_NUMPARTIDA := 0;
      END;

      V_PARTIDAS := 0;


      /* BUSCA OS PRODUTOS DA NOTA QUE POSSUEM O VALOR */
      FOR PRODUTO IN
         (SELECT IT.CDPRODUTO, NRSEQITPROD, COUNT(*) PRODQUANT
            FROM ITEMPRODUTO IT
           WHERE (IT.CDFILIAL = P_CDFILIAL)
             AND (IT.NRLANCTONF = P_NRLANCTONF)
             AND (IT.VRCONTITEM > 0)
           GROUP BY IT.CDPRODUTO, NRSEQITPROD
        ORDER BY NRSEQITPROD)LOOP

         /* VERIFICA SE A CONTA CONTBIL POR TIPO DE OPERAO EST PARAMETRIZADA, CASO ESTEJA, SER UTILIZADA. */
         IF V_CDCONTATIPOOPER IS NOT NULL THEN
            V_CDCONTAPROD := V_CDCONTATIPOOPER;
         END IF;

         IF V_CDCONTAPROD IS NULL THEN
            /* CASO A CONTA CONTBIL AINDA ESTEJA VAZIA, DEVE-SE BUSCAR O CDARVPROD
               PARA BUSCAR A CONTA CONTBIL DO PRODUTO POR TIPO DE OPERAO. */
            BEGIN
               SELECT P.CDARVPROD
                 INTO V_CDARVPROD
                 FROM PRODUTO P, PRODFILI PR
                WHERE (P.CDPRODUTO = PRODUTO.CDPRODUTO);
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_CDARVPROD := NULL;
            END;

            /* BUSCA A CONTA CONTBIL DO PRODUTO POR TIPO DE OPERAO. */
            BEGIN
               SELECT C.CDCTBLPRODTO
                 INTO V_CDCONTAPROD
                 FROM CTBPRDTPOPER C, (SELECT MAX(P.CDARVPROD) CDARVPROD
                                         FROM CTBPRDTPOPER A, PRODUTO P
                                        WHERE IDENTRSAIDOP = NOTA.IDENTRSAIDOP
                                          AND CDTIPOOPER   = NOTA.CDTIPOOPER
                                          AND P.CDPRODUTO  = A.CDPRODUTO
                                          AND (INSTR(V_CDARVPROD, RTRIM(P.CDARVPROD)) = 1)
                                          AND A.CDCTBLPRODTO IS NOT NULL) PR, PRODUTO P
                 WHERE IDENTRSAIDOP = NOTA.IDENTRSAIDOP
                   AND CDTIPOOPER   = NOTA.CDTIPOOPER
                   AND C.CDPRODUTO  = P.CDPRODUTO
                   AND P.CDARVPROD = PR.CDARVPROD;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_CDCONTAPROD := NULL;
            END;

            IF V_CDCONTAPROD IS NULL THEN
               BEGIN
                  SELECT CONTCTBL_PRODUTO(PRODUTO.CDPRODUTO, 'E', P_CDFILIAL)
                    INTO V_CDCONTAPROD
                    FROM DUAL;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_CDCONTAPROD := NULL;
               END;
            END IF;
         END IF;

         FOR IMPOSTO IN
            (SELECT ROUND(VRIMPOSTOIT, 2) VRIMPOSTO
              FROM ITEMPROIMPOS IMP
             WHERE NRLANCTONF  = P_NRLANCTONF
               AND CDFILIAL    = P_CDFILIAL
               AND NRSEQITPROD = PRODUTO.NRSEQITPROD
               AND CDFISCALIT = '1') LOOP

            IF IMPOSTO.VRIMPOSTO > 0 THEN
               /* MONTA O HISTRICO DO LANAMENTO CONTBIL */
               CTB_DFE_HISTORICO(P_CDFILIAL, P_NRLANCTONF, V_CDHISTPADR, V_DSHISTLANC);

               /* TRAS A INFORMAO DE CDIGO COMERCIAL E TIPO GERENCIAL DA CONTA CONTBIL */
               BUSCA_TPCOMERCIAL(V_CDCONTAPROD, V_IDCOME, V_IDCCUS);

               /* TRAZ O CDIGO COMERCIAL PARA O LANAMENTO CONTBIL DEPENDENDO DA ORIGEM DA NOTA. */
               BEGIN
                  SELECT DECODE(NOTA.IDORIGDESTNF, 'F', NOTA.CDFORNECED, DECODE(NOTA.IDORIGDESTNF, 'C', NOTA.CDCLIENTE, NULL))
                    INTO V_CDCOMERCIAL
                    FROM DUAL;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_CDCOMERCIAL := NULL;
               END;

               /* PEGA O VALOR DO IMPOSTO */
               V_VRIMPOSTO := IMPOSTO.VRIMPOSTO * P_FATOR;

               /* ARMAZENA O VALOR PARA A PARTIDA */
               V_VRCONTITEM := - V_VRIMPOSTO;

               /* REALIZA A SOMA DE TODAS AS PARTIDAS DOS IMPOSTOS */
               V_TOTALPARTIDAS := V_TOTALPARTIDAS + V_VRIMPOSTO;

               V_INPARTIDAS := V_INPARTIDAS + 1;

               IF V_INPARTIDAS = PRODUTO.PRODQUANT THEN
                  IF ABS(ROUND(ABS(V_TOTALPARTIDAS), 2)) <> ROUND(ABS(P_VRLANCTO), 2) THEN
                     V_VRCONTITEM := V_VRCONTITEM - V_TOTALPARTIDAS;
                  END IF;
               END IF;

               IF V_ACUMULA = 'S' THEN
                  BEGIN
                     SELECT COUNT(*), NRSEQCTBTEMP
                       INTO V_COUNT, V_NRSEQLANC
                       FROM LANCCTBTEMP
                      WHERE NRLANCCTBTEMP = P_NRLANCTBTEMP
                        AND CDEMPRESA = NOTA.CDEMPRESA
                        AND CDCONTCTBL = V_CDCONTAPROD
                        AND CDLANCCTBCOME = V_CDCOMERCIAL;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_COUNT := 0;
                        V_NRSEQLANC := NULL;
                  END;
                  IF V_COUNT = 0 THEN
                     
                     V_NUMPARTIDA := V_NUMPARTIDA + 1;
                     INSERT INTO LANCCTBTEMP
                        (CDEMPRESA, NRLANCCTBTEMP, CDDOCUTEMP, NRSEQCTBTEMP, CDCONTCTBL, CDHISTPADR,
                         DSHISTCTB, DTLANCCTBTEMP, VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, IDSISTEMA)
                     VALUES
                        (NOTA.CDEMPRESA, P_NRLANCTBTEMP, NOTA.NRNOTAFISC, LPAD(TO_CHAR(V_NUMPARTIDA),5,'0'), V_CDCONTAPROD, V_CDHISTPADR,
                         V_DSHISTLANC, NOTA.DTENTRSAID, V_VRCONTITEM, V_IDCOME, V_CDCOMERCIAL, 'DFE');
                     IF V_CONTCCUS <> 'N' THEN
                        IF V_IDCCUS <> 'O' THEN
                           V_CDCENTCUST := BUSCA_CCUSTO(V_CDFILIAL, NOTA.CDEMPRESA);
                           INSERT INTO RATECTBTEMP
                              (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                           VALUES
                              (NOTA.CDEMPRESA, P_NRLANCTBTEMP, LPAD(TO_CHAR(V_NUMPARTIDA),5,'0'), NOTA.CDFILIRECE, V_CDCENTCUST, V_VRCONTITEM, NOTA.DTENTRSAID, '00001');
                        END IF;
                     END IF;
                  ELSE
                     /* CASO EXISTA UMA PARTIDA, O VALOR DA MESMA  ATUALIZADO. */
                     UPDATE LANCCTBTEMP
                        SET VRLANCCTBTEMP = VRLANCCTBTEMP + V_VRCONTITEM
                      WHERE NRLANCCTBTEMP = P_NRLANCTBTEMP
                        AND CDEMPRESA = NOTA.CDEMPRESA
                        AND NRSEQCTBTEMP = V_NRSEQLANC;
                     IF V_CONTCCUS <> 'N' THEN
                        IF V_IDCCUS <> 'O' THEN
                           UPDATE RATECTBTEMP
                              SET VRRATECTBTEMP = VRRATECTBTEMP + V_VRCONTITEM
                            WHERE CDFILIAL = NOTA.CDFILIRECE
                              AND CDCENTCUST = V_CDCENTCUST
                              AND NRSEQCTBTEMP = V_NRSEQLANC;
                         END IF;
                      END IF;
                  END IF;
               ELSE
                  /* CASO NO ACUMULE O VALOR DAS PARTIDAS,  FEITA UMA NOVA PARTIDA PARA O LANAMENTO */
                  V_NUMPARTIDA := V_NUMPARTIDA + 1;
                  INSERT INTO LANCCTBTEMP
                     (CDEMPRESA, NRLANCCTBTEMP, CDDOCUTEMP, NRSEQCTBTEMP, CDCONTCTBL, CDHISTPADR,
                      DSHISTCTB, DTLANCCTBTEMP, VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, IDSISTEMA)
                  VALUES
                     (NOTA.CDEMPRESA, P_NRLANCTBTEMP, NOTA.NRNOTAFISC, LPAD(TO_CHAR(V_NUMPARTIDA),5,'0'), V_CDCONTAPROD, V_CDHISTPADR,
                      V_DSHISTLANC, NOTA.DTENTRSAID, V_VRCONTITEM, V_IDCOME, V_CDCOMERCIAL, 'DFE');
                  IF V_CONTCCUS <> 'N' THEN
                     IF V_IDCCUS <> 'O' THEN
                        V_CDCENTCUST := BUSCA_CCUSTO(V_CDFILIAL, NOTA.CDEMPRESA);
                        INSERT INTO RATECTBTEMP
                           (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                        VALUES
                           (NOTA.CDEMPRESA, P_NRLANCTBTEMP, LPAD(TO_CHAR(V_NUMPARTIDA),5,'0'), NOTA.CDFILIRECE, V_CDCENTCUST, V_VRCONTITEM, NOTA.DTENTRSAID, '00001');
                     END IF;
                  END IF;
               END IF;
            END IF;
         END LOOP;
         V_CDCONTAPROD := NULL;
      END LOOP;
   END LOOP;
   P_VRLANCTO := P_VRLANCTO;
END;
/
